/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is MozTweaks.
 *
 * The Initial Developer of the Original Code is Jens Bannmann.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s) (alphabetical order):
 *  Jens Bannmann <jens.b@web.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

const POPUP_PREF = "dom.disable_open_during_load";
var mtPopupButton = document.getElementById("mtpopup-button");

var mtPopupTimeout = false;
function mtTogglePopups(e) {
  if (e.button == 0) {
    if (mtPopupTimeout) {
      mtEndPopupTimeout();
    } else {
      pref.setBoolPref(POPUP_PREF, !pref.getBoolPref(POPUP_PREF));
    }
  } else if (e.button == 1
      && mtPref.getBoolPref(POPUP_PREF)
      && !mtPopupTimeout) {
    mtBeginPopupTimeout();
  }
}

function mtBeginPopupTimeout() {
  mtPopupTimeout = true;
  mtPref.setBoolPref(POPUP_PREF, false);
  window.setTimeout(mtEndPopupTimeout, 15000);
}

function mtEndPopupTimeout() {
  if (mtPopupTimeout == true) {
    mtPopupTimeout = false;
    mtPref.setBoolPref(POPUP_PREF, true);
  }
}

function mtPopupPrefObserver() {
  try {
    mtPref.QueryInterface(Components.interfaces.nsIPrefBranchInternal)
        .addObserver(this.domain, this, false);
  } catch(ex) {
    dump("MozTweaks: Failed to observe prefs: " + ex + "\n");
  }
}
mtPopupPrefObserver.prototype = {
  domain: "dom.",
  observe: function(subject, topic, prefName) {
    if (prefName == POPUP_PREF) {
      mtUpdatePopupButton();
    }
  }
}

function mtUpdatePopupButton() {
  mtPopupButton.setAttribute('state',
      mtPopupTimeout ? "timeout"
          : (pref.getBoolPref(POPUP_PREF) ? "disallow" : "allow"));
}

function mtInitPopupToggler() {
  if (mtPopupButton) {
    mtPopupButton.setAttribute('hidden',
                               !mtGetPref("showPopupToggler", "Bool", false));
    mtUpdatePopupButton();
  }
}

// startup code
window.mtPrefObserver = new mtPopupPrefObserver();
